import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;

/**
   Ramka zawierajca panel edytora, pole tekstowe i przycisk Load
   umoliwiajce wprowadzenie adresu URL i zaadowanie strony,
   a take przycisk Wstecz umoliwiajcy powrt do poprzedniej strony.
*/
public class HelpFrame extends JFrame {
   final Stack<String> urlStack = new Stack<String>();
   final JEditorPane editorPane = new JEditorPane();
   final JTextField url = new JTextField(30);

   public HelpFrame( URL url0, String tyt ) {
      this();
      setTitle(tyt);
      url.setVisible( false );  // UKRYJ ADRES
      url.setText(url0.toString() );
      url.setEditable(false);
      try {
         editorPane.setPage(url0);
         urlStack.push(url0.toString() );
      } catch( IOException e ) {
          editorPane.setText("Exception: " + e);
      }
   }
   public HelpFrame() {
      setTitle("EditorPaneTest");
      setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
      // instaluje obiekt nasuchujcy hipercza
      editorPane.setEditable(false);
      editorPane.addHyperlinkListener(new
         HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent event) {
               if(event.getEventType() == HyperlinkEvent.EventType.ACTIVATED){
                  try {
                     // zapamituje adres URL dla potrzeb przycisku Wstecz
                     urlStack.push(event.getURL().toString());
                     // prezentuje adres URL w polu tekstowym
                     url.setText(event.getURL().toString());
                     editorPane.setPage(event.getURL());
                  }
                  catch (IOException e) {
                     editorPane.setText("Exception: " + e);
                  }
               }
            }
         });
      // tworzy obiekt nasuchujcy przycisku Load
      ActionListener listener = new
         ActionListener() {
            public void actionPerformed(ActionEvent event) {
               try {
                  // zapamituje adres URL dla potrzeb przycisku Wstecz
                  urlStack.push(url.getText());
                  editorPane.setPage(url.getText());
               }
               catch (IOException e) {
                  editorPane.setText("Exception: " + e);
               }
            }
         };
      url.addActionListener(listener);

      // tworzy przycisk Wstecz i jego obiekt nasuchujcy
      JButton backButton = new JButton("Cofnij");
      backButton.addActionListener(new
         ActionListener() {
            public void actionPerformed(ActionEvent event) {
               if (urlStack.size() <= 1) return;
               try {
                  // pobiera adres URL
                  urlStack.pop();
                  // umieszcza adres URL w polu tekstowym
                  String urlString = urlStack.peek();
                  url.setText(urlString);
                  editorPane.setPage(urlString);
               }
               catch (IOException e) {
                  editorPane.setText("Exception: " + e);
               }
            }
         });

      add(new JScrollPane(editorPane), BorderLayout.CENTER);

      // umieszcza wszystkie komponenty na gwnym panelu okna

      JPanel panel = new JPanel();
//UKRYJ ADRES      panel.add(new JLabel("URL"));
      panel.add(url);
      panel.add(backButton);
      add(panel, BorderLayout.SOUTH);
   }

   private static final int DEFAULT_WIDTH = 600;
   private static final int DEFAULT_HEIGHT = 400;
}
