// 22.VIII.2006
import java.io.File;
import java.util.*;

/** Prosta klasa FileFilter, operujca na rozszerzeniach plikw,
 * podobnie jak klasa ExtentionFilter dostarczana jako przykad
 * JDK. Ma ona by obsugiwana w przyszych wersjach pakietu
 * Swing.
 */
class JFileFilter extends javax.swing.filechooser.FileFilter {
    protected String description;
    protected ArrayList exts = new ArrayList();

    public void addType(String s) {
        exts.add(s);
    }

    /** Zwraca true jest akceptowany przez filtr. */
    public boolean accept(File f) {
        // Maa sztuczka: jeli nie zostanie zastosowana, to
        // w oknie dialogowym pojawi si wycznie nazwy
        // katalogw zakoczone jednym z podanych rozszerze.
        if (f.isDirectory()) {
            return true;

        } else if (f.isFile()) {
            Iterator it = exts.iterator();
            while (it.hasNext()) {
                String s0 = f.getName().toLowerCase(),
                       s1 = ((String)it.next()).toLowerCase();
                if(s0.endsWith( s1 ) )
                   return true;   // ignoruje wielko liter
/* Dawne: Zwracao uwag na wielko liter
                if (f.getName().endsWith((String)it.next()))
                    return true;
Dawne - koniec */
            }
        }

        // Plik ktry nie pasuje, lub jakie dziwactow (np. plik sterownika
        // w systemie UNIX).
        return false;
    }

    /** Okrela opis danego filtra. */
    public void setDescription(String s) {
        description = s;
    }
    /** Zwraca opis filtra. */
    public String getDescription() {
        return description;
    }
}
